From 0413ee270951ee06a806424e85cbb83967819ed1 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 02 2021 21:57:48 +0000
Subject: [PATCH 1984/2232] Restore swapping Str and Slice in member function form only


---

diff --git a/include/cxx.h b/include/cxx.h
index ee4de41..03f719f 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -125,6 +125,8 @@ public:
   bool operator>(const Str &) const noexcept;
   bool operator>=(const Str &) const noexcept;
 
+  void swap(Str &) noexcept;
+
 private:
   std::array<std::uintptr_t, 2> repr;
 };
@@ -175,6 +177,8 @@ public:
   iterator begin() const noexcept;
   iterator end() const noexcept;
 
+  void swap(Slice &) noexcept;
+
 private:
   // Not necessarily ABI compatible with &[T]. Codegen will translate to
   // cxx::rust_slice::RustSlice which matches this layout.
@@ -666,6 +670,11 @@ typename Slice<T>::iterator Slice<T>::end() const noexcept {
   it.pos = static_cast<char *>(it.pos) + it.stride * this->len;
   return it;
 }
+
+template <typename T>
+void Slice<T>::swap(Slice &rhs) noexcept {
+  std::swap(*this, rhs);
+}
 #endif // CXXBRIDGE1_RUST_SLICE
 
 #ifndef CXXBRIDGE1_RUST_BOX
diff --git a/src/cxx.cc b/src/cxx.cc
index 5d38966..605845e 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -267,6 +267,8 @@ bool Str::operator>(const Str &rhs) const noexcept { return rhs < *this; }
 
 bool Str::operator>=(const Str &rhs) const noexcept { return rhs <= *this; }
 
+void Str::swap(Str &rhs) noexcept { std::swap(*this, rhs); }
+
 std::ostream &operator<<(std::ostream &os, const Str &s) {
   os.write(s.data(), s.size());
   return os;

